PSocket Class Referenceabstract

A network communications channel. More...

`#include <socket.h>`

Inheritance diagram for PSocket:

## Classes

class | SelectList
| List of sockets used for Select() function. More...

## Public Member Functions

PBoolean | Read (void *ptr, PINDEX len)
| Low level read from the channel. More...
| ~PSocket ()
Socket options functions
PBoolean | SetOption (int option, int value, int level=SOL_SOCKET)
| Set options on the socket. More...
PBoolean | SetOption (int option, const void *valuePtr, PINDEX valueSize, int level=SOL_SOCKET)
| Set options on the socket. More...
PBoolean | GetOption (int option, int &value, int level=SOL_SOCKET)
| Get options on the socket. More...
PBoolean | GetOption (int option, void *valuePtr, PINDEX valueSize, int level=SOL_SOCKET)
| Get options on the socket. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two strings. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open. More...
virtual PString | GetName () const
| Get the platform and I/O channel type name of the channel. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
virtual PChannel * | GetBaseReadChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
virtual PChannel * | GetBaseWriteChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual PBoolean | Close ()
| Close the channel, shutting down the link to the data source. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions

Multiple socket selection functions
static int | Select (PSocket &sock1, PSocket &sock2)
| Select a socket with available data. More...
static int | Select (PSocket &sock1, PSocket &sock2, const PTimeInterval &timeout)
| Select a socket with available data. More...
static Errors | Select (SelectList &read)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, const PTimeInterval &timeout)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, SelectList &write)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, SelectList &write, const PTimeInterval &timeout)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, SelectList &write, SelectList &except)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, SelectList &write, SelectList &except, const PTimeInterval &timeout)
| Select a socket with available data. More...
Integer conversion functions
static WORD | Host2Net (WORD v)
| Convert from host to network byte order. More...
static DWORD | Host2Net (DWORD v)
| Convert from host to network byte order. More...
static WORD | Net2Host (WORD v)
| Convert from network to host byte order. More...
static DWORD | Net2Host (DWORD v)
| Convert from network to host byte order. More...
Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Protected Member Functions

| PSocket ()
virtual PBoolean | OpenSocket ()=0
virtual const char * | GetProtocolName () const =0
| This function returns the protocol name for the socket type. More...
int | os_close ()
int | os_socket (int af, int type, int proto)
PBoolean | os_connect (struct sockaddr *sin, PINDEX size)
PBoolean | os_recvfrom (void *buf, PINDEX len, int flags, struct sockaddr *from, PINDEX *fromlen)
PBoolean | os_sendto (const void *buf, PINDEX len, int flags, struct sockaddr *to, PINDEX tolen)
PBoolean | os_accept (PSocket &listener, struct sockaddr *addr, PINDEX *size)
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

WORD | port
| Port to be used by the socket when opening the channel. More...
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Socket establishment functions

enum | Reusability { CanReuseAddress, AddressIsExclusive }
| Flags to reuse of port numbers in Listen() function. More...
virtual PBoolean | Connect (const PString &address)
| Connect a socket to a remote host on the specified port number. More...
virtual PBoolean | Listen (unsigned queueSize=5, WORD port=0, Reusability reuse=AddressIsExclusive)
| Listen on a socket for a remote host on the specified port number. More...
virtual PBoolean | Accept (PSocket &socket)
| Open a socket to a remote host on the specified port number. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a socket. More...

## Port/Service database functions

virtual WORD | GetPortByService (const PString &service) const
| Get the port number for the specified service name. More...
virtual PString | GetServiceByPort (WORD port) const
| Get the service name from the port number. More...
void | SetPort (WORD port)
| Set the port number for the channel. More...
void | SetPort (const PString &service)
| Set the port number for the channel. More...
WORD | GetPort () const
| Get the port the TCP socket channel object instance is using. More...
PString | GetService () const
| Get a service name for the port number the TCP socket channel object instance is using. More...
static WORD | GetProtocolByName (const PString &name)
| Get the number of the protocol associated with the specified name. More...
static PString | GetNameByProtocol (WORD proto)
| Get the name of the protocol number specified. More...
static WORD | GetPortByService (const char *protocol, const PString &service)
| Get the port number for the specified service name. More...
static PString | GetServiceByPort (const char *protocol, WORD port)
| Get the service name from the port number. More...

## Additional Inherited Members

Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Detailed Description

A network communications channel.

This is based on the concepts in the Berkley Sockets library.

A socket represents a bidirectional communications channel to a port at a remote host.

## Member Enumeration Documentation

## Reusability

enum PSocket::Reusability

Flags to reuse of port numbers in Listen() function.

Enumerator
CanReuseAddress |
AddressIsExclusive |

## Constructor & Destructor Documentation

## PSocket()

PSocket::PSocket | ( |  | ) |

protected

## ~PSocket()

PSocket::~PSocket | ( |  | ) |

## Member Function Documentation

## Accept()

virtual PBoolean PSocket::Accept | ( | PSocket & | socket | ) |

virtual

Open a socket to a remote host on the specified port number.

This is an "accepting" socket. When a "listening" socket has a pending connection to make, this will accept a connection made by the "connecting" socket created to establish a link.

The port that the socket uses is the one used in the Listen() command of the `socket` parameter. Note an error occurs if the `socket` parameter has not had the Listen() function called on it.

Note that this function will block until a remote system connects to the port number specified in the "listening" socket. The time that the function will block is determined by the read timeout of the `socket` parameter. This will normally be PMaxTimeInterval which indicates an infinite time.

The default behaviour is to assert.

Returns
  true if the channel was successfully opened.

Parameters

  socket | Listening socket making the connection.

Reimplemented in PSocksSocket, PTCPSocket, and PTelnetSocket.

## Connect()

virtual PBoolean PSocket::Connect | ( | const PString & | address | ) |

virtual

Connect a socket to a remote host on the specified port number.

This is typically used by the client or initiator of a communications channel. This connects to a "listening" socket at the other end of the communications channel.

Use the SetReadTimeout() function to set a maximum time for the Connect().

Returns
  true if the channel was successfully connected to the remote host.

Parameters

  address | Address of remote machine to connect to.

Reimplemented in PIPSocket, PSocksUDPSocket, PEthSocket, PSocksSocket, PTelnetSocket, and PUDPSocket.

## GetNameByProtocol()

static PString PSocket::GetNameByProtocol | ( | WORD | proto | ) |

static

Get the name of the protocol number specified.

Returns
  Name of protocol or the number if the protocol was not found.

Parameters

  proto | Number of protocol.

## GetOption() [1/2]

PBoolean PSocket::GetOption | ( | int | option,
|  | int & | value,
|  | int | level = `SOL_SOCKET`
| ) |  |

Get options on the socket.

These options are defined as Berkeley socket options of the class SOL_SOCKET.

Returns
  true if the option was successfully retrieved.

Parameters

  option | Option to get.
  value | Integer to receive value.
  level | Level for option.

## GetOption() [2/2]

PBoolean PSocket::GetOption | ( | int | option,
|  | void * | valuePtr,
|  | PINDEX | valueSize,
|  | int | level = `SOL_SOCKET`
| ) |  |

Get options on the socket.

These options are defined as Berkeley socket options of the class SOL_SOCKET.

Returns
  true if the option was successfully retrieved.

Parameters

  option | Option to get.
  valuePtr | Pointer to buffer for value.
  valueSize | Size of buffer to receive value.
  level | Level for option

## GetPort()

WORD PSocket::GetPort | ( |  | ) | const

Get the port the TCP socket channel object instance is using.

Returns
  Port number.

## GetPortByService() [1/2]

virtual WORD PSocket::GetPortByService | ( | const PString & | service | ) | const

virtual

Get the port number for the specified service name.

Parameters

  service | Name of service to get port number for.

## GetPortByService() [2/2]

static WORD PSocket::GetPortByService | ( | const char * | protocol,
|  | const PString & | service
| ) |  |

static

Get the port number for the specified service name.

A name is a unique string contained in a system database. The parameter here may be either this unique name, an integer value or both separated by a space (name then integer). In the latter case the integer value is used if the name cannot be found in the database.

The exact behviour of this function is dependent on whether TCP or UDP transport is being used. The PTCPSocket and PUDPSocket classes will implement this function.

The static version of the function is independent of the socket type as its first parameter may be "tcp" or "udp".

Returns
  Port number for service name, or 0 if service cannot be found.

Parameters

  protocol | Protocol type for port lookup.
  service | Name of service to get port number for.

## GetProtocolByName()

static WORD PSocket::GetProtocolByName | ( | const PString & | name | ) |

static

Get the number of the protocol associated with the specified name.

Returns
  Number of protocol or 0 if the protocol was not found.

Parameters

  name | Name of protocol.

## GetProtocolName()

virtual const char* PSocket::GetProtocolName | ( |  | ) | const

protected pure virtual

This function returns the protocol name for the socket type.

Implemented in PEthSocket, PTCPSocket, PUDPSocket, and PICMPSocket.

Referenced by Net2Host(), and P_timeval::operator*().

## GetService()

PString PSocket::GetService | ( |  | ) | const

Get a service name for the port number the TCP socket channel object instance is using.

Returns
  String service name or a string representation of the port number if no service with that number can be found.

## GetServiceByPort() [1/2]

virtual PString PSocket::GetServiceByPort | ( | WORD | port | ) | const

virtual

Get the service name from the port number.

Parameters

  port | Number for service to find name of.

## GetServiceByPort() [2/2]

static PString PSocket::GetServiceByPort | ( | const char * | protocol,
|  | WORD | port
| ) |  |

static

Get the service name from the port number.

A service name is a unique string contained in a system database. The parameter here may be either this unique name, an integer value or both separated by a space (name then integer). In the latter case the integer value is used if the name cannot be found in the database.

The exact behviour of this function is dependent on whether TCP or UDP transport is being used. The PTCPSocket and PUDPSocket classes will implement this function.

The static version of the function is independent of the socket type as its first parameter may be "tcp" or "udp".

Returns
  Service name for port number.

Parameters

  protocol | Protocol type for port lookup
  port | Number for service to find name of.

## Host2Net() [1/2]

static WORD PSocket::Host2Net | ( | WORD | v | ) |

inline static

Convert from host to network byte order.

Referenced by PSocket::SelectList::operator-=().

## Host2Net() [2/2]

static DWORD PSocket::Host2Net | ( | DWORD | v | ) |

inline static

Convert from host to network byte order.

## Listen()

virtual PBoolean PSocket::Listen | ( | unsigned | queueSize = `5`,
|  | WORD | port = `0`,
|  | Reusability | reuse = `AddressIsExclusive`
| ) |  |

virtual

Listen on a socket for a remote host on the specified port number.

This may be used for server based applications. A "connecting" socket begins a connection by initiating a connection to this socket. An active socket of this type is then used to generate other "accepting" sockets which establish a two way communications channel with the "connecting" socket.

If the `port` parameter is zero then the port number as defined by the object instance construction or the descendent classes SetPort() or SetService() function.

Returns
  true if the channel was successfully opened.

Parameters

  queueSize | Number of pending accepts that may be queued.
  port | Port number to use for the connection.
  reuse | Can/Cant listen more than once.

Reimplemented in PIPSocket, PSocksUDPSocket, PEthSocket, PSocksSocket, and PTCPSocket.

## Net2Host() [1/2]

static WORD PSocket::Net2Host | ( | WORD | v | ) |

inline static

Convert from network to host byte order.

## Net2Host() [2/2]

static DWORD PSocket::Net2Host | ( | DWORD | v | ) |

inline static

Convert from network to host byte order.

References GetProtocolName(), OpenSocket(), os_accept(), os_close(), os_connect(), os_recvfrom(), os_sendto(), and os_socket().

## OpenSocket()

virtual PBoolean PSocket::OpenSocket | ( |  | ) |

protected pure virtual

Implemented in PEthSocket, PTCPSocket, PUDPSocket, and PICMPSocket.

Referenced by Net2Host(), and P_timeval::operator*().

## os_accept()

PBoolean PSocket::os_accept | ( | PSocket & | listener,
|  | struct sockaddr * | addr,
|  | PINDEX * | size
| ) |  |

protected

Referenced by Net2Host().

## os_close()

int PSocket::os_close | ( |  | ) |

protected

Referenced by Net2Host().

## os_connect()

PBoolean PSocket::os_connect | ( | struct sockaddr * | sin,
|  | PINDEX | size
| ) |  |

protected

Referenced by Net2Host().

## os_recvfrom()

PBoolean PSocket::os_recvfrom | ( | void * | buf,
|  | PINDEX | len,
|  | int | flags,
|  | struct sockaddr * | from,
|  | PINDEX * | fromlen
| ) |  |

protected

Referenced by Net2Host().

## os_sendto()

PBoolean PSocket::os_sendto | ( | const void * | buf,
|  | PINDEX | len,
|  | int | flags,
|  | struct sockaddr * | to,
|  | PINDEX | tolen
| ) |  |

protected

Referenced by Net2Host().

## os_socket()

int PSocket::os_socket | ( | int | af,
|  | int | type,
|  | int | proto
| ) |  |

protected

Referenced by Net2Host().

## Read()

PBoolean PSocket::Read | ( | void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level read from the channel.

This function may block until the requested number of characters were read or the read timeout was reached. The GetLastReadCount() function returns the actual number of bytes read.

The GetErrorCode() function should be consulted after Read() returns false to determine what caused the failure.

Returns
  true indicates that at least one character was read from the channel. false means no bytes were read due to timeout or some other I/O error.

Reimplemented from PChannel.

Reimplemented in PUDPSocket, PTelnetSocket, and PTCPSocket.

## Select() [1/8]

static int PSocket::Select | ( | PSocket & | sock1,
|  | PSocket & | sock2
| ) |  |

static

Select a socket with available data.

Parameters

  sock1 | First socket to check for readability.
  sock2 | Second socket to check for readability.

Referenced by PSocket::SelectList::operator-=().

## Select() [2/8]

static int PSocket::Select | ( | PSocket & | sock1,
|  | PSocket & | sock2,
|  | const PTimeInterval & | timeout
| ) |  |

static

Select a socket with available data.

Parameters

  sock1 | First socket to check for readability.
  sock2 | Second socket to check for readability.
  timeout | Timeout for wait on read/write data.

## Select() [3/8]

static Errors PSocket::Select | ( | SelectList & | read | ) |

static

Select a socket with available data.

Parameters

  read | List of sockets to check for readability.

## Select() [4/8]

static Errors PSocket::Select | ( | SelectList & | read,
|  | const PTimeInterval & | timeout
| ) |  |

static

Select a socket with available data.

Parameters

  read | List of sockets to check for readability.
  timeout | Timeout for wait on read/write data.

## Select() [5/8]

static Errors PSocket::Select | ( | SelectList & | read,
|  | SelectList & | write
| ) |  |

static

Select a socket with available data.

Parameters

  read | List of sockets to check for readability.
  write | List of sockets to check for writability.

## Select() [6/8]

static Errors PSocket::Select | ( | SelectList & | read,
|  | SelectList & | write,
|  | const PTimeInterval & | timeout
| ) |  |

static

Select a socket with available data.

Parameters

  read | List of sockets to check for readability.
  write | List of sockets to check for writability.
  timeout | Timeout for wait on read/write data.

## Select() [7/8]

static Errors PSocket::Select | ( | SelectList & | read,
|  | SelectList & | write,
|  | SelectList & | except
| ) |  |

static

Select a socket with available data.

Parameters

  read | List of sockets to check for readability.
  write | List of sockets to check for writability.
  except | List of sockets to check for exceptions.

## Select() [8/8]

static Errors PSocket::Select | ( | SelectList & | read,
|  | SelectList & | write,
|  | SelectList & | except,
|  | const PTimeInterval & | timeout
| ) |  |

static

Select a socket with available data.

This function will block until the timeout or data is available to be read or written to the specified sockets.

The read, write and except lists are modified by the call so that only the sockets that have data available are present. If the call timed out then all of these lists will be empty.

If no timeout is specified then the call will block until a socket has data available.

Returns
  true if the select was successful or timed out, false if an error occurred. If a timeout occurred then the lists returned will be empty.

For the versions taking sockets directly instead of lists the integer returned is >0 for an error being a value from the PChannel::Errors enum, 0 for a timeout, -1 for the first socket having read data, -2 for the second socket and -3 for both.

Parameters

  read | List of sockets to check for readability.
  write | List of sockets to check for writability.
  except | List of sockets to check for exceptions.
  timeout | Timeout for wait on read/write data.

## SetOption() [1/2]

PBoolean PSocket::SetOption | ( | int | option,
|  | int | value,
|  | int | level = `SOL_SOCKET`
| ) |  |

Set options on the socket.

These options are defined as Berkeley socket options of the class SOL_SOCKET.

Returns
  true if the option was successfully set.

Parameters

  option | Option to set.
  value | New value for option.
  level | Level for option.

## SetOption() [2/2]

PBoolean PSocket::SetOption | ( | int | option,
|  | const void * | valuePtr,
|  | PINDEX | valueSize,
|  | int | level = `SOL_SOCKET`
| ) |  |

Set options on the socket.

These options are defined as Berkeley socket options of the class SOL_SOCKET.

Returns
  true if the option was successfully set.

Parameters

  option | Option to set.
  valuePtr | Pointer to new value for option.
  valueSize | Size of new value.
  level | Level for option.

## SetPort() [1/2]

void PSocket::SetPort | ( | WORD | port | ) |

Set the port number for the channel.

Parameters

  port | New port number for the channel.

## SetPort() [2/2]

void PSocket::SetPort | ( | const PString & | service | ) |

Set the port number for the channel.

This a 16 bit number representing an agreed high level protocol type. The string version looks up a database of names to find the number for the string name.

A service name is a unique string contained in a system database. The parameter here may be either this unique name, an integer value or both separated by a space (name then integer). In the latter case the integer value is used if the name cannot be found in the database.

The port number may not be changed while the port is open and the function will assert if an attempt is made to do so.

Parameters

  service | Service name to describe the port number.

## Shutdown()

virtual PBoolean PSocket::Shutdown | ( | ShutdownValue | option | ) |

virtual

Close one or both of the data streams associated with a socket.

Returns
  true if the shutdown was performed

Parameters

  option | Flag for shutdown of read, write or both.

Reimplemented from PChannel.

## Member Data Documentation

## port

WORD PSocket::port

protected

Port to be used by the socket when opening the channel.

Referenced by PIPSocketAddressAndPort::AsString(), PSTUNClient::GetName(), and PIPSocketAddressAndPort::SetPort().

The documentation for this class was generated from the following file:

- socket.h